/*
 * sphSphereObject.h
 *
 *  Created on: 2009/10/29
 *      Author: hira
 */

#ifndef _SPHSPHEREOBJECT_H_
#define _SPHSPHEREOBJECT_H_

#include "base/sphBase.h"
#include "app/sphSphere.h"
#include "solverbase/sphSolverManager.h"
#include "solverbase/sphCouplerManager.h"
//#include "solverbase/sphFlowBase.h"
#include "parallel/sphParaManager.h"
#include "config/sphElem.h"

// using namespace std;
class sphFlowBase;

class sphSphereObject: public sphBase
{
private:

protected:
  int m_sphereId;
  std::string m_sphereLabel;
  sphSphere* m_sphere;
  const sphElem* m_configElem;

public:
  sphSphereObject();
  sphSphereObject(const char* label, int id);
  virtual ~sphSphereObject();

  void setSphere(sphSphere* object);
  const sphSphere* getSphere();
  int getSphereId() const;
  std::string getSphereLabel() const;

  sphSolverManager* getSolverManager();
  sphCouplerManager* getCouplerManager();
  sphParaManager* getParaManager();
  const sphFlowBase* getFlow() const;
  sphFlowBase* getFlow();
  const sphElem* getConfigElem() const;
  virtual bool setConfigElem(const sphElem* elem);

};

#endif /* _SPHSPHEREOBJECT_H_ */
