/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphDefine.h
 * Sphere Define Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphDefine.h
 * Sphere定義ヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */

#ifndef _SPHDEFINE_H_
#define _SPHDEFINE_H_

#define SPH_LABEL_MAX_STR_LENGTH 256

#define SPHERE_ERROR            -1
#define SPHERE_TERMINATE        0
#define SPHERE_SUCCESS          1

typedef enum { X_DIR = 0, Y_DIR = 1, Z_DIR = 2, DIR_UNKNOWN = -1 } DirFaceType;
typedef enum { MINUS_DIR = -1, PLUS_DIR = 1 } DirAxisType;


/**
* ボクセル面タイプ
*/
typedef enum {
    FACE_UNKNOWN = 0,              //< Unknown
    XFACE_PLUS = 1,            //< Iプラス方向面
    XFACE_MINUS = 2,          //< Iマイナス方向面
    YFACE_PLUS = 3,            //< Jプラス方向面
    YFACE_MINUS = 4,          //< Jマイナス方向面
    ZFACE_PLUS = 5,            //< Kプラス方向面
    ZFACE_MINUS = 6           //< Kマイナス方向面
    } FaceType;


#endif /* _SPHDEFINE_H_ */
