/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphCfgBase.h
 * Configuration super Class Header File
 * @author     hira
 * @date       2009/02/20
 *
 * \~japanese
 * @file sphCfgBase.h
 * コンフィギュレーション基底クラスヘッダーファイル
 * @author     hira
 * @date       2009/02/20
 */

#ifndef _SPHCFGBASE_H_
#define _SPHCFGBASE_H_

#include <malloc.h>
#include <deque>
#include <fcntl.h>
#include <iostream>
#include <map>
#include <sstream>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <libxml/xpathInternals.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "base/sphBase.h"
#include "spl/spl.h"
#include "spl/splmpi.h"
#include "config/sphConfigDefine.h"

class sphCfgBase : public virtual sphBase
{
protected:
  xmlChar* getXmlAttribute(xmlNodePtr node, const xmlChar* src_name) const;

public:
  sphCfgBase();
  virtual
  ~sphCfgBase();
};

#endif /* _SPHCFGBASE_H_ */
