/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphDataDefs.h
 * Data Parameter Define file
 * @author     hira
 * @date       2009/02/20
 *
 * \~japanese
 * @file sphDataDefs.h
 * データパラメータの定義ファイル
 * @author     hira
 * @date       2009/02/20
 */

#ifndef _SPH_DATA_DEFS_H_
#define _SPH_DATA_DEFS_H_

/**
 * \~english
 * data class Enumerated type
 *
 * \~japanese
 * データクラスタイプ列挙型
 */
typedef enum {
   SPH_DC_INVALID = 0          ///<    未定
 , SPH_DC_ARRAY_1D            ///<    1Dデータクラス データ配列{i}
 , SPH_DC_ARRAY_1DN            ///<    1Dデータクラス データ配列{i, l}
 , SPH_DC_ARRAY_1DNRV          ///<    1Dデータクラス データ配列{l, i}
 , SPH_DC_ARRAY_2D            ///<    2Dデータクラス データ配列{i, j}
 , SPH_DC_ARRAY_2DN            ///<    2Dデータクラス データ配列{i, j, l}
 , SPH_DC_ARRAY_2DNRV          ///<    2Dデータクラス データ配列{l, i, j}
 , SPH_DC_ARRAY_3D            ///<    3Dデータクラス データ配列{i, j, k}
 , SPH_DC_ARRAY_3DN            ///<    3Dデータクラス データ配列{i, j, k, l}
 , SPH_DC_ARRAY_3DNRV          ///<    3Dデータクラス データ配列{l, i, j, k}
// ----- add 20100420 @tamaki begin -----
 /* unstruct data class */
 , SPH_DC_UNST_NODE
 , SPH_DC_UNST_NODE_N
 , SPH_DC_UNST_NODE_NRV
 , SPH_DC_UNST_ELEM
 , SPH_DC_UNST_ELEM_N
 , SPH_DC_UNST_ELEM_NRV
// ----- add 20100420 @tamaki end   -----
} SphDCType;


/**
 * データ定義位置.
 * CRDDEF_UNKNOWN:不明
 * CRDDEF_REGULAR:格子点
 * CRDDEF_COLLOCATE:格子中央
 * CRDDEF_STAGGERED1:staggered(外側)
 * CRDDEF_STAGGERED2:staggered(内側)
 */
typedef enum {
  CRDDEF_UNKNOWN = 0,
  CRDDEF_REGULAR = 1,
  CRDDEF_COLLOCATE = 2,
  CRDDEF_STAGGERED1 = 3,
  CRDDEF_STAGGERED2 = 4
} SphCrdDef;


#endif // _SPH_DATA_DEFS_H_

