/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphFileHeader.h
 * Sphere File Header Information Class Header File
 * @author     hira
 * @date       2009/09/07
 *
 * \~japanese
 * @file sphFileHeader.h
 * Sphereのファイルヘッダー情報クラスヘッダーファイル
 * @author     hira
 * @date       2009/09/07
 */

#ifndef _SPHFILEHEADER_H_
#define _SPHFILEHEADER_H_

#include <limits.h>
#include <iostream>
#include <string>
#include <vector>

#include "base/sphBase.h"
#include "spl/spl.h"
#include "spl/splmpi.h"

/**
 * Sphereのファイルヘッダー基底情報クラス
 */
class sphFileHeader: public virtual sphBase
{
public:
  /**
   * \~english
   * Constructor
   *
   * \~japanese
   * コンストラクタ
   */
  sphFileHeader()
  {
  };

  /**
   * \~english
   * Destructor
   *
   * \~japanese
   * デストラクタ
   */
  virtual ~sphFileHeader()
  {
  };

  virtual bool initialize() = 0;
  virtual bool finalize() = 0;
  virtual bool checkHeader() const = 0;
  virtual void printHeaderInfo() = 0;
};

#endif /* _SPHFILEHEADER_H_ */
