/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphUnstMeshDouble.h
 * Double unstruct Mesh Information Classes Header File
 * @author     tamaki
 * @date       2010/04/22
 *
 * \~japanese
 * @file sphUnstMeshDouble.h
 * 倍精度非構造格子情報クラス郡ヘッダーファイル
 * @author     tamaki
 * @date       2010/04/22
 */

#ifndef _SPHUNSTMESHINFODOUBLE_H_
#define _SPHUNSTMESHINFODOUBLE_H_


#include "parallel/sphUnstMesh.h"
//#include "spl/splmpi.h"

/**
 * \~english
 * Double Unstruct Mesh Information Class
 *
 * \~japanese
 * 倍精度非構造格子情報クラス
 */
class sphUnstMeshDouble : public sphUnstMesh {
friend class sphUnstParaController;

// ----- datas -----
protected:
  double **m_sData;
  double **m_rData;

public:
  double *xyz;

// ----- methods -----
protected:
  sphUnstMeshDouble();
  virtual bool readNode(const char* fn);

public:
  virtual ~sphUnstMeshDouble();
  virtual bool comm(float  *x) { return false; };
  virtual bool wait(float  *x) { return false; };
  virtual bool comm(double  *x);
  virtual bool wait(double  *x);
  virtual bool readDistMesh(const char* filename);

  virtual bool getCoord(double **c) const { *c = xyz; return true; };
};

#endif /* _SPHUNSTMESHINFODOUBLE_H_ */

