/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphUnstMeshFloat.h
 * Float unstruct Mesh Information Classes Header File
 * @author     tamaki
 * @date       2010/04/22
 *
 * \~japanese
 * @file sphUnstMeshFloat.h
 * 単精度非構造格子情報クラス郡ヘッダーファイル
 * @author     tamaki
 * @date       2010/04/22
 */

#ifndef _SPHUNSTMESHINFOFLOAT_H_
#define _SPHUNSTMESHINFOFLOAT_H_


#include "parallel/sphUnstMesh.h"
//#include "spl/splmpi.h"

/**
 * \~english
 * UNstruct Mesh Information Class
 *
 * \~japanese
 * 非構造格子情報クラス
 */
class sphUnstMeshFloat : public sphUnstMesh {
friend class sphUnstParaController;

// ----- datas -----
protected:
  float **m_sData;
  float **m_rData;

public:
  float *xyz;

// ----- methods -----
protected:
  sphUnstMeshFloat();
  virtual bool readNode(const char* fn);

public:
  virtual ~sphUnstMeshFloat();
  virtual bool comm(float  *x);
  virtual bool wait(float  *x);
  virtual bool comm(double  *x) { return false; };
  virtual bool wait(double  *x) { return false; };
  virtual bool readDistMesh(const char* filename);

  virtual bool getCoord(float **c) const { *c = xyz; return true; };
};

#endif /* _SPHUNSTMESHINFOFLOAT_H_ */

