/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgBase.h
 * コンフィグレーション基底クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_BASE_
#define _SKL_CFG_BASE_

#include <libxml/tree.h>
#include "SklCfgErrMsg.h"

#include "base/sphBase.h"

/**
 * コンフィグレーションネームスペース
 */
namespace SklCfg {

/**
 * コンフィグレーション基底クラス
 */
class SklCfgBase : public sphBase {
protected:
  int StrCompare(const char *s1, const char *s2, size_t n = 0) const;
  int StrCaseCompare(const char *s1, const char *s2, size_t n = 0) const;

  virtual bool Parse(xmlNodePtr node) = 0;

  void CfgMsg(char* format, ...) const;
  void CfgErrMsg(char* format, ...) const;
  void CfgWarnMsg(char* format, ...) const;
  void CfgDbgMsg(char* format, ...) const;

public:
  SklCfgBase();
  virtual ~SklCfgBase();
};

} // end of namespace SklCfg

#endif // _SKL_CFG_BASE_

