/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgDefName.h
 * コンフィグレーション要素名・属性名定義ファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_DEF_NAME_
#define _SKL_CFG_DEF_NAME_

namespace SklCfg {

/*
  _SKL_CFG_NNAME_USRDEF_ELEM_		user configure Elem Name
  _SKL_CFG_NNAME_USRDEF_ELEM_		user configure Elem Name
  _SKL_CFG_ANAME_USRDEF_ELEM_..._	user configure Elem Name
  _SKL_CFG_NNAME_USRDEF_PARAM_		user configure Param Name
  _SKL_CFG_ANAME_USRDEF_PARAM_..._	user configure Param Name
  _SKL_CFG_AVAL_USRDEF_PARAM_..._	user configure Param Name
  _SKL_CFG_AVAL_USRDEF_ELEM_..._	user configure Elem Name

  _SKL_CFG_NNAME_..._			SPHERE configure Name
  _SKL_CFG_ANAME_..._			SPHERE configure Name
*/

#define _SKL_CFG_NNAME_USRDEF_ELEM_          "Elem"
#define _SKL_CFG_ANAME_USRDEF_ELEM_NAME_     "name"
#define _SKL_CFG_ANAME_USRDEF_ELEM_ID_       "id"
#define _SKL_CFG_ANAME_USRDEF_ELEM_COMMENT_  "comment"

#define _SKL_CFG_NNAME_USRDEF_PARAM_         "Param"
#define _SKL_CFG_ANAME_USRDEF_PARAM_NAME_    "name"
#define _SKL_CFG_ANAME_USRDEF_PARAM_DTYPE_   "dtype"
#define _SKL_CFG_ANAME_USRDEF_PARAM_VALUE_   "value"
#define _SKL_CFG_ANAME_USRDEF_PARAM_ID_      "id"
#define _SKL_CFG_ANAME_USRDEF_PARAM_COMMENT_ "comment"
#define _SKL_CFG_AVAL_USRDEF_PARAM_INT_      "int"
#define _SKL_CFG_AVAL_USRDEF_PARAM_REAL_     "real"
#define _SKL_CFG_AVAL_USRDEF_PARAM_STRING_   "string"

#define _SKL_CFG_NNAME_SPHERECONFIG_         "SphereConfig"
#define _SKL_CFG_ANAME_SOLVERTYPE_           "SolverType"

#define _SKL_CFG_NNAME_DOMAININFO_              "DomainInfo"
#define _SKL_CFG_NNAME_DOMAININFO_VOXEL_ORIGIN_ "VoxelOrigin"
#define _SKL_CFG_NNAME_DOMAININFO_VOXEL_SIZE_   "VoxelSize"
#define _SKL_CFG_NNAME_DOMAININFO_VOXEL_WIDTH_  "VoxelWidth"
#define _SKL_CFG_NNAME_DOMAININFO_VOXEL_PITCH_  "VoxelPitch"
#define _SKL_CFG_ANAME_DOMAININFO_IMAX_         "ix"
#define _SKL_CFG_ANAME_DOMAININFO_JMAX_         "jx"
#define _SKL_CFG_ANAME_DOMAININFO_KMAX_         "kx"
#define _SKL_CFG_ANAME_DOMAININFO_XORG_         "ox"
#define _SKL_CFG_ANAME_DOMAININFO_YORG_         "oy"
#define _SKL_CFG_ANAME_DOMAININFO_ZORG_         "oz"
#define _SKL_CFG_ANAME_DOMAININFO_XWID_         "wx"
#define _SKL_CFG_ANAME_DOMAININFO_YWID_         "wy"
#define _SKL_CFG_ANAME_DOMAININFO_ZWID_         "wz"
#define _SKL_CFG_ANAME_DOMAININFO_XPIT_         "dx"
#define _SKL_CFG_ANAME_DOMAININFO_YPIT_         "dy"
#define _SKL_CFG_ANAME_DOMAININFO_ZPIT_         "dz"

#define _SKL_CFG_NNAME_STEER_                   "Steer"
#define _SKL_CFG_NNAME_STEER_CALC_STEPS_        "CalculationSteps"
#define _SKL_CFG_NNAME_STEER_START_COND_        "StartCondition"
#define _SKL_CFG_NNAME_STEER_CHECK_MODE_        "CheckMode"
#define _SKL_CFG_NNAME_STEER_INPUT_DATA_        "InputData"
#define _SKL_CFG_NNAME_STEER_OUTPUT_DATA_       "OutputData"
#define _SKL_CFG_NNAME_STEER_IN_FILE_           "InFile"
#define _SKL_CFG_NNAME_STEER_OUT_FILE_          "OutFile"
#define _SKL_CFG_NNAME_STEER_MONITOR_           "Monitor"
#define _SKL_CFG_NNAME_STEER_HISTORY_           "History"
#define _SKL_CFG_ANAME_STEER_STEP_              "step"
#define _SKL_CFG_ANAME_STEER_TYPE_              "type"
#define _SKL_CFG_ANAME_STEER_TYPE_INITIAL_      "Initial"
#define _SKL_CFG_ANAME_STEER_TYPE_RESTART_      "Restart"
#define _SKL_CFG_ANAME_STEER_ATTR_              "attr"
#define _SKL_CFG_ANAME_STEER_FORMAT_            "format"
#define _SKL_CFG_ANAME_STEER_FILE_NAME_         "fname"
#define _SKL_CFG_ANAME_STEER_BASE_DIR_          "basedir"
#define _SKL_CFG_ANAME_STEER_INTERVAL_          "interval"
#define _SKL_CFG_ANAME_STEER_BASE_NAME          "basename"
#define _SKL_CFG_ANAME_STEER_MULTI_IO_          "multi"
#define _SKL_CFG_ANAME_STEER_COORD_ID_          "coord"

#define _SKL_CFG_ANAME_STEER_FILE_TYPE_SPH      "sph"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_SVX      "svx"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_OTV      "otv"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_OVX      "ovx"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_FDV      "fdv"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_NBF      "nbf"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_NVX      "nvx"
#define _SKL_CFG_ANAME_STEER_FILE_TYPE_VCR      "vcar"

#define _SKL_CFG_NNAME_PARAMETER_               "Parameter"
#define _SKL_CFG_NNAME_INNER_BND_               "InnerBoundary"
#define _SKL_CFG_NNAME_OUTER_BND_               "OuterBoundary"
#define _SKL_CFG_NNAME_MDM_TABLE_               "Medium_Table"
#define _SKL_CFG_NNAME_BC_TABLE_                "BC_Table"
#define _SKL_CFG_NNAME_MBX_TABLE_               "MultiBoxDivTable"

// for BCTable file and MDMTable file
#define _SKL_CFG_ANAME_DOMAININFO_BCTBL_        "BCTBL"
#define _SKL_CFG_ANAME_DOMAININFO_MDMTBL_       "MDMTBL"
#define _SKL_CFG_ANAME_DOMAININFO_MBXTBL_       "MBXTBL"

// for Boundary Condition Table
#define _SKL_CFG_NNAME_BC_                      "BCbind"
#define _SKL_CFG_AVAL_USRDEF_Elem_BC_UX_        "Ux"
#define _SKL_CFG_AVAL_USRDEF_Elem_BC_UY_        "Uy"
#define _SKL_CFG_AVAL_USRDEF_Elem_BC_UZ_        "Uz"
#define _SKL_CFG_AVAL_USRDEF_Elem_BC_PRS_       "Prs"
#define _SKL_CFG_AVAL_USRDEF_Elem_BC_TMP_       "Tmp"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_TYPE_         "Type"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_DIFTYPE_      "DifType"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_FIXED_        "Fixed"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_DIFFERENTIAL_ "Differential"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_COMPOUND_     "Compound"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_VAL_          "Val"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_FUNC_         "Func"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_UNN_          "Unn"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_CONVECT_      "Convect"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_T_         "t"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_N_         "n"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_X_         "x"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_Y_         "y"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_Z_         "z"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_0_         "0"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_1_         "1"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_2_         "2"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_I_         "i"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_J_         "j"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_K_         "k"
#define _SKL_CFG_AVAL_USRDEF_PARAM_BC_DBC_       "DBC"

// for Medium Table
#define _SKL_CFG_NNAME_MDM_                      "MDMbind"
#define _SKL_CFG_AVAL_USRDEF_PARAM_MTL_MEDIUM_   "Medium"

// for Coord
#define _SKL_CFG_COORD_ELEM_NAME_COORD_          "Coord"
#define _SKL_CFG_COORD_ELEM_NAME_INPUT_          "Input"
#define _SKL_CFG_COORD_ELEM_NAME_OUTPUT_         "Output"

#define _SKL_CFG_COORD_PARAM_NAME_ATTR_          "Attr"
#define _SKL_CFG_COORD_PARAM_NAME_GUIDECELL_     "GuideCell"

#define _SKL_CFG_COORD_PARAM_NAME_IN_FNAME_      "FileName"
#define _SKL_CFG_COORD_PARAM_NAME_IN_CONT_GC_    "ContainedGC"
#define _SKL_CFG_COORD_PARAM_NAME_IN_MULTI_      "Multi"

#define _SKL_CFG_COORD_PARAM_NAME_OUT_BNAME_     "BaseName"
#define _SKL_CFG_COORD_PARAM_NAME_OUT_INT_       "Interval"
#define _SKL_CFG_COORD_PARAM_NAME_OUT_GC_NUM_    "OutGCNum"
#define _SKL_CFG_COORD_PARAM_NAME_OUT_FTYPE_     "FileType"
#define _SKL_CFG_COORD_PARAM_NAME_OUT_MULTI_     "Multi"

#define _SKL_CFG_COORD_PARAM_VALUE_RECTCOORD_    "RectCoord"
#define _SKL_CFG_COORD_PARAM_VALUE_MULTI_YES_    "yes"
#define _SKL_CFG_COORD_PARAM_VALUE_MULTI_NO_     "no"
#define _SKL_CFG_COORD_PARAM_VALUE_FTYPE_BIN_    "Binary"
#define _SKL_CFG_COORD_PARAM_VALUE_FTYPE_ASCII_  "Ascii"

} // end of namespace SklCfg

#endif // _SKL_CFG_DEF_NAME_

