/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgDomainInfo.h
 * コンフィグレーションDomainInfo要素クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_DOMAININFO_
#define _SKL_CFG_DOMAININFO_

#include "SklCfgNodeBase.h"

namespace SklCfg {

/**
 * コンフィグレーションDomainInfo要素クラス
 */
class SklCfgDomainInfo : public SklCfgNodeBase {
protected:
  float* m_voxOrg;              ///< 原点座標
  unsigned int* m_voxSize;      ///< ボクセルサイズ
  float* m_voxWidth;            ///< ボクセル幅
  float* m_voxPitch;            ///< ピッチ

  virtual bool CheckNodeName(const char* nname);
  virtual bool ParseSklDefNode(xmlNodePtr node);
  bool ParseVoxelOrigin(xmlNodePtr node);
  bool ParseVoxelSize(xmlNodePtr node);
  bool ParseVoxelWidth(xmlNodePtr node);
  bool ParseVoxelPitch(xmlNodePtr node);
  virtual bool Verification();

public:
  SklCfgDomainInfo();
  virtual ~SklCfgDomainInfo();

  // Getting Methods
  bool GetVoxelOrigin(float& x, float& y, float& z) const;
  bool GetVoxelSize(unsigned int& i, unsigned int& j, unsigned int& k) const;
  bool GetVoxelWidth(float& x, float& y, float& z) const;
  bool GetVoxelPitch(float& x, float& y, float& z) const;

#ifdef DEBUG
  virtual void Print();
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_CFG_DOMAININFO_

