/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgErrMsg.h
 * コンフィグレーションエラーメッセージ定義ファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_ERROR_MESSAGES_
#define _SKL_CFG_ERROR_MESSAGES_

namespace SklCfg {

#define _SKL_CFG_ERR_0001_ "Element name pointer is NULL."
#define _SKL_CFG_ERR_0002_ "Invalid element name. : %s"
#define _SKL_CFG_ERR_0003_ "xmlNodePtr pointer is NULL."
#define _SKL_CFG_ERR_0004_ "Couldn't get attribute. : (Element)%s -> (attr)%s"
#define _SKL_CFG_ERR_0005_ "Memory allocation error."
#define _SKL_CFG_ERR_0006_ "Verification error. : %s"
#define _SKL_CFG_ERR_0007_ "Invalid attribute value. : (Element)%s -> (attr)%s -> (val)%s"
#define _SKL_CFG_ERR_0008_ "History attribute \"fname\" has already been defined."
#define _SKL_CFG_ERR_0009_ "InFile attribute \"attr\" has already been defined."
#define _SKL_CFG_ERR_0010_ "InFile attribute \"format\"has already been defined."
#define _SKL_CFG_ERR_0011_ "InFile attribute \"fname\"has already been defined."
#define _SKL_CFG_ERR_0012_ "InputData attribute \"basedir\"has already been defined."
#define _SKL_CFG_ERR_0013_ "OutFile attribute \"attr\" has already been defined."
#define _SKL_CFG_ERR_0014_ "OutFile attribute \"format\" has already been defined."
#define _SKL_CFG_ERR_0015_ "OutFile attribute \"basename\" has already been defined."
#define _SKL_CFG_ERR_0016_ "OutputData attribute \"basedir\"has already been defined."
#define _SKL_CFG_ERR_0017_ "SphereConfig : XML file is NULL."
#define _SKL_CFG_ERR_0018_ "SphereConfig : file open error. (%s)"
#define _SKL_CFG_ERR_0019_ "SphereConfig : can't get file stat. (fstat error)"
#define _SKL_CFG_ERR_0020_ "SphereConfig : buf size error. (st_buf)"
#define _SKL_CFG_ERR_0021_ "SphereConfig : xml stream is NULL."
#define _SKL_CFG_ERR_0022_ "SphereConfig : xmlParseMemory error."
#define _SKL_CFG_ERR_0023_ "SphereConfig : The operative Element doesn't exist in the XML file."
#define _SKL_CFG_ERR_0024_ "SphereConfig : Element(DomainInfo) redefined."
#define _SKL_CFG_ERR_0025_ "SphereConfig : Element(Steer) redefined."
#define _SKL_CFG_ERR_0026_ "SphereConfig : Element(Parameter) redefined."
#define _SKL_CFG_ERR_0027_ "SphereConfig : Element(InnerBoundary) redefined."
#define _SKL_CFG_ERR_0028_ "SphereConfig : Element(OuterBoundary) redefined."
#define _SKL_CFG_ERR_0029_ "UserDefinedElement : attr(name) pointer is NULL."
#define _SKL_CFG_ERR_0030_ "UserDefinedElement : attr(comment) pointer is NULL."
#define _SKL_CFG_ERR_0031_ "UserDefinedElement : Element(Param) pointer is NULL."
#define _SKL_CFG_ERR_0032_ "UserDefinedElement : Element(Elem) pointer is NULL."
#define _SKL_CFG_ERR_0033_ "File name is NULL."
#define _SKL_CFG_ERR_0034_ "History attribute \"attr\" has already been defined."
#define _SKL_CFG_ERR_0035_ "Can't get Param data_value."
#define _SKL_CFG_ERR_0036_ "Can't get Elem name."
// add(Vsphere 1.6.0) start for bug fix at 2008/06/20 by @hira
#define _SKL_CFG_ERR_0037_ "SphereConfig : It's a directory. (%s)"
// add(Vsphere 1.6.0) end for bug fix at 2008/06/20 by @hira
#define _SKL_CFG_ERR_0038_ ""
#define _SKL_CFG_ERR_0039_ ""

#define _SKL_CFG_ERR_0050_ "Voxel origin is not set."
#define _SKL_CFG_ERR_0051_ "Voxel size is not set."
#define _SKL_CFG_ERR_0052_ "Voxel width is not set."
#define _SKL_CFG_ERR_0053_ "Voxel pitch is not set."
#define _SKL_CFG_ERR_0054_ "%s"
#define _SKL_CFG_ERR_0055_ " Invalid parameter (%s)."
#define _SKL_CFG_ERR_0056_ "The specified character array is too short."
#define _SKL_CFG_ERR_0057_ "(CfgElem::GetValues) format-string too long(less than 256 charactors)."
#define _SKL_CFG_ERR_0058_ "Invalid argument list."
#define _SKL_CFG_ERR_0059_ "(CfgParam::GetData) Invalid data type. data_type must %s*."
#define _SKL_CFG_ERR_0060_ ""
#define _SKL_CFG_ERR_0061_ ""
#define _SKL_CFG_ERR_0062_ ""
#define _SKL_CFG_ERR_0063_ ""
#define _SKL_CFG_ERR_0064_ ""
#define _SKL_CFG_ERR_0065_ ""
#define _SKL_CFG_ERR_0066_ ""
#define _SKL_CFG_ERR_0067_ ""
#define _SKL_CFG_ERR_0068_ ""
#define _SKL_CFG_ERR_0069_ ""
#define _SKL_CFG_ERR_0070_ ""
#define _SKL_CFG_ERR_0071_ ""
#define _SKL_CFG_ERR_0072_ ""
#define _SKL_CFG_ERR_0073_ ""
#define _SKL_CFG_ERR_0074_ ""
#define _SKL_CFG_ERR_0075_ ""
#define _SKL_CFG_ERR_0076_ ""
#define _SKL_CFG_ERR_0077_ ""
#define _SKL_CFG_ERR_0078_ ""
#define _SKL_CFG_ERR_0079_ ""
#define _SKL_CFG_ERR_0080_ ""


// for boundary and medium condition
#define _SKL_CFG_ERR_1001_ "SphereConfig : Element(BCbind) redefined."
#define _SKL_CFG_ERR_1002_ "Invalid BC Type name. : %s"
#define _SKL_CFG_ERR_1003_ "Can't insert BC to BCTable."
#define _SKL_CFG_ERR_1004_ "NULL check error."
#define _SKL_CFG_ERR_1005_ "Can't get BC data from BCTable."
#define _SKL_CFG_ERR_1006_ "Can't set BC data (Fixed condition)."
#define _SKL_CFG_ERR_1007_ "Can't set BC data (Differential condition)."
#define _SKL_CFG_ERR_1008_ "Can't set BC data (Compound condition)."
#define _SKL_CFG_ERR_1009_ "Can't add medium data to MDM_List."
#define _SKL_CFG_ERR_1010_ ""
#define _SKL_CFG_ERR_1011_ ""
#define _SKL_CFG_ERR_1012_ ""
#define _SKL_CFG_ERR_1013_ ""
#define _SKL_CFG_ERR_1014_ ""
#define _SKL_CFG_ERR_1015_ ""
#define _SKL_CFG_ERR_1016_ ""

} // end of namespace SklCfg

#endif // _SKL_CFG_ERROR_MESSAGES_

