/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgHistory.h
 * コンフィグレーションHistory要素クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_STEER_HISTORY_
#define _SKL_CFG_STEER_HISTORY_

#include "SklCfgNodeBase.h"

namespace SklCfg {

/**
 * コンフィグレーションHistory要素クラス
 */
class SklCfgHistory : public SklCfgNodeBase {
protected:
  unsigned int m_interval;      ///< インターバル
  char* m_fname;                ///< ファイル名
  char* m_attr;                 ///< 識別ラベル
  virtual bool CheckNodeName(const char* nname);
  virtual bool ParseSklDefNode(xmlNodePtr node);
  virtual bool Verification();
  bool ParseInterval(xmlNodePtr node);
  bool ParseFileName(xmlNodePtr node);
  bool ParseAttr(xmlNodePtr node);

public:
  SklCfgHistory();
  virtual ~SklCfgHistory();
  virtual bool ParseNode(xmlNodePtr node);
  bool CreateFileName(const char* basedir);

  // Getting Methods
  unsigned int GetInterval() const;
  const char* GetFileName() const;
  const char* GetAttr() const;

#ifdef DEBUG
  virtual void Print();
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_CFG_STEER_HISTORY_

