/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgSteerInputData.h
 * コンフィグレーションInputData要素クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_STEER_INPUT_DATA_
#define _SKL_CFG_STEER_INPUT_DATA_

#include "SklCfgNodeBase.h"
#include "SklCfgInFile.h"

namespace SklCfg {
/**
 * コンフィグレーションInputData要素クラス
 */
class SklCfgSteerInputData : public SklCfgNodeBase {
protected:
  char* m_baseDir;        ///< ディレクトリパス
  list<SklCfgInFile*> m_inFileList;   ///< InFile要素リスト
  virtual bool CheckNodeName(const char* nname);
  virtual bool ParseSklDefNode(xmlNodePtr node);
  virtual bool Verification();

public:
  SklCfgSteerInputData();
  virtual ~SklCfgSteerInputData();
  virtual bool ParseNode(xmlNodePtr node);

  // Getting Methods
  const char* GetBaseDir() const;
  unsigned int GetInFileSize() const;
  const SklCfgInFile* GetInFileFirst() const;
  const SklCfgInFile* GetInFileNext(const SklCfgInFile* file) const;

#ifdef DEBUG
  virtual void Print();
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_CFG_STEER_INPUT_DATA_

