/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgUsrDefTopNode.h
 * コンフィグレーションユーザ定義要素クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_CFG_USER_DEFINE_TOP_NODE_
#define _SKL_CFG_USER_DEFINE_TOP_NODE_

#include "SklCfgNodeBase.h"

namespace SklCfg {

/**
 * コンフィグレーションユーザ定義要素クラス
 */
class SklCfgUsrDefTopNode : public SklCfgNodeBase {
protected:
  virtual bool Parse(xmlNodePtr node);
  virtual bool CheckNodeName(const char* nname);
  virtual bool ParseSklDefNode(xmlNodePtr node);
  virtual bool Verification();

public:
  SklCfgUsrDefTopNode();
  virtual ~SklCfgUsrDefTopNode();

#ifdef DEBUG
  virtual void Print();
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_CFG_USER_DEFINE_TOP_NODE_

