/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklIBCConfig.h
 * InnerBoundaryコンフィグレーション情報格納クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_SOLVER_INNER_BOUNDARY_CONFIG_H_
#define _SKL_SOLVER_INNER_BOUNDARY_CONFIG_H_

#include "SklCfgDatas.h"
#include "SklCfgBase.h"
#include "SklCfgInnerBnd.h"

namespace SklCfg {
/**
 * InnerBoundaryコンフィグレーション情報格納クラス
 */
class SklIBCConfig : public SklCfgBase {
protected:
  /// InnerBoundary要素
  SklCfgInnerBnd* m_bnd; // not delete

  void Initialize();
  bool SklParseConfigFile(const char* fname);
  bool SklParseConfigFileForParallel(const char* fname);
  bool ParseConfigStream(const size_t sz, const char* stream);
  bool SklParse(xmlNodePtr node);
  virtual bool Parse(xmlNodePtr node);

public:
  SklIBCConfig();
  virtual ~SklIBCConfig();
  bool SklParseConfig(const char* fname);

  void SetBnd(SklCfgInnerBnd* bnd);
  SklCfgInnerBnd* GetBnd() const;

#ifdef DEBUG
  virtual void Print() const;
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_SOLVER_INNER_BOUNDARY_CONFIG_H_

