/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklMBoxConfig.h
 * MultiBoxDivTableコンフィグレーション情報格納クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_SOLVER_MULTI_BOX_CONFIG_H_
#define _SKL_SOLVER_MULTI_BOX_CONFIG_H_

#include "SklCfgDatas.h"
#include "SklCfgBase.h"
#include "SklCfgMBoxTable.h"

namespace SklCfg {
/**
 * MultiBoxDivTableコンフィグレーション情報格納クラス
 */
class SklMBoxConfig : public SklCfgBase {
protected:
  /// MultiBoxDivTable要素
  SklCfgMBoxTable* m_mbxTable; // not delete

  void Initialize();
  bool SklParseConfigFile(const char* fname);
  bool SklParseConfigFileForParallel(const char* fname);
  bool ParseConfigStream(const size_t sz, const char* stream);
  bool SklParse(xmlNodePtr node);
  virtual bool Parse(xmlNodePtr node);

public:
  SklMBoxConfig();
  virtual ~SklMBoxConfig();
  bool SklParseConfig(const char* fname);

  void SetMBoxTable(SklCfgMBoxTable* mbxTbl);
  SklCfgMBoxTable* GetMBoxTable() const;

#ifdef DEBUG
  virtual void Print() const;
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_SOLVER_MULTI_BOX_CONFIG_H_

