/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklMDMConfig.h
 * Medium_Tableコンフィグレーション情報格納クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_SOLVER_MEDIUM_CONFIG_H_
#define _SKL_SOLVER_MEDIUM_CONFIG_H_

#include "SklCfgDatas.h"
#include "SklCfgBase.h"
#include "SklCfgMdmTable.h"

namespace SklCfg {
/**
 * Medium_Tableコンフィグレーション情報格納クラス
 */
class SklMDMConfig : public SklCfgBase {
protected:
  /// Medium_Table要素
  SklCfgMdmTable* m_mdmTable; // not delete

  void Initialize();
  bool SklParseConfigFile(const char* fname);
  bool SklParseConfigFileForParallel(const char* fname);
  bool ParseConfigStream(const size_t sz, const char* stream);
  bool SklParse(xmlNodePtr node);
  virtual bool Parse(xmlNodePtr node);

public:
  SklMDMConfig();
  virtual ~SklMDMConfig();
  bool SklParseConfig(const char* fname);

  void SetMdmTable(SklCfgMdmTable* mdmTbl);
  SklCfgMdmTable* GetMdmTable() const;

#ifdef DEBUG
  virtual void Print() const;
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_SOLVER_MEDIUM_CONFIG_H_

