/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklOBCConfig.h
 * OuterBoundaryコンフィグレーション情報格納クラスヘッダーファイル
 * @author     riken
 * @date       2010/10/01
 */

#ifndef _SKL_SOLVER_OUTER_BOUNDARY_CONFIG_H_
#define _SKL_SOLVER_OUTER_BOUNDARY_CONFIG_H_

#include "SklCfgDatas.h"
#include "SklCfgBase.h"
#include "SklCfgOuterBnd.h"

namespace SklCfg {
/**
 * OuterBoundaryコンフィグレーション情報格納クラス
 */
class SklOBCConfig : public SklCfgBase {
protected:
  /// OuterBoundary
  SklCfgOuterBnd* m_bnd; // not delete

  void Initialize();
  bool SklParseConfigFile(const char* fname);
  bool SklParseConfigFileForParallel(const char* fname);
  bool ParseConfigStream(const size_t sz, const char* stream);
  bool SklParse(xmlNodePtr node);
  virtual bool Parse(xmlNodePtr node);

public:
  SklOBCConfig();
  virtual ~SklOBCConfig();
  bool SklParseConfig(const char* fname);

  void SetBnd(SklCfgOuterBnd* bnd);
  SklCfgOuterBnd* GetBnd() const;

#ifdef DEBUG
  virtual void Print() const;
#endif //DEBUG
};

} // end of namespace SklCfg

#endif // _SKL_SOLVER_OUTER_BOUNDARY_CONFIG_H_

