/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphCouplerFactory.h
 * Sphere Coupler Factory Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphCouplerFactory.h
 * Sphereカプラー生成クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */
#ifndef _SPHCOUPLERFACTORY_H_
#define _SPHCOUPLERFACTORY_H_

#include "base/sphBase.h"
#include "solverbase/sphCouplerBase.h"


/**
 * Sphereカプラー生成クラス
 */
class sphCouplerFactory: public sphBase
{
public:
  sphCouplerFactory();
  virtual ~sphCouplerFactory();
  sphCouplerBase* factoryCoupler(const char* class_name, const char* label, int id) const;

};

#endif /* _SPHCOUPLERFACTORY_H_ */
