/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphCouplerManager.h
 * Sphere Coupler Manager Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphCouplerManager.h
 * Sphereカプラーマネージャークラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */

#ifndef _SPHCOUPLERMANAGER_H_
#define _SPHCOUPLERMANAGER_H_

#include "base/sphBase.h"

//using namespace std;
class sphCouplerBase;

/**
 * Sphereカプラーマネージャークラス
 */
class sphCouplerManager: public sphBase
{
protected:
  std::map<int, sphCouplerBase*> m_mapCoupler;

  bool initialize();
  bool finalize();

public:
  sphCouplerManager();
  virtual ~sphCouplerManager();

  int getCouplerCount() const;
  sphCouplerBase* getCoupler(int id) const;
  sphCouplerBase* getCouplerById(int couplerId) const;
  sphCouplerBase* getCouplerByLabel(const char* couplerLabel) const;

  bool addCoupler(sphCouplerBase* coupler);
};

#endif /* _SPHCOUPLERMANAGER_H_ */


