/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphCouplerSv2Uns.h
 * Sphere Simple Voxel to Unsteady Coupler super Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphCouplerSv2Uns.h
 * Sphere構造格子To非構造格子カプラー基底クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */

#ifndef _SPHCOUPLERSV2UNS_H_
#define _SPHCOUPLERSV2UNS_H_

#include "sphCouplerBase.h"

/**
 * Sphere構造格子To非構造格子カプラー基底クラス
 */
class sphCouplerSv2Uns: public sphCouplerBase
{
protected:
  virtual bool communicateData();
  virtual bool interpolate();

public:
  sphCouplerSv2Uns();
  sphCouplerSv2Uns(const char* label);
  sphCouplerSv2Uns(const char* label, int id);
  virtual ~sphCouplerSv2Uns();

  // -1 : error
  //  0 : forced terminated
  //  1 : Normality
  virtual int initializeCoupler(const char* ref_reg_label = NULL, const char* upd_reg_label = NULL);
  virtual int executeCoupler();
  virtual int postCoupler();

};

#endif /* _SPHCOUPLERSV2UNS_H_ */
