/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphCouplerUns2Sv.h
 * Sphere Unsteady to Simple Voxel Coupler super Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphCouplerUns2Sv.h
 * Sphere非構造格子To構造格子カプラー基底クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */

#ifndef _SPHCOUPLERUNS2SV_H_
#define _SPHCOUPLERUNS2SV_H_

#include "sphCouplerBase.h"

/**
 * Sphere非構造格子To構造格子カプラー基底クラス
 */
class sphCouplerUns2Sv: public sphCouplerBase
{

protected:
  virtual bool communicateData();
  virtual bool interpolate();

public:
  sphCouplerUns2Sv();
  sphCouplerUns2Sv(const char* label);
  sphCouplerUns2Sv(const char* label, int id);
  virtual ~sphCouplerUns2Sv();

  // -1 : error
  //  0 : forced terminated
  //  1 : Normality
  virtual int initializeCoupler(const char* ref_reg_label = NULL, const char* upd_reg_label = NULL);
  virtual int executeCoupler();
  virtual int postCoupler();

};

#endif /* _SPHCOUPLERUNS2SV_H_ */
