/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphFlowBase.h
 * Sphere Flow super Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphFlowBase.h
 * Sphereフロー基底クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */
#ifndef _SPHFLOWBASE_H_
#define _SPHFLOWBASE_H_

#include "app/sphSphereObject.h"
#include "base/sphStepTime.h"

//using namespace std;

/**
 * Sphereフロー基底クラス
 */
class sphFlowBase: public sphSphereObject
{

protected:
  sphStepTime* m_steptime;

  bool initialize();

  virtual int initializeSolvers() = 0;
  virtual int mainSolvers() = 0;
  virtual int postSolvers() = 0;

public:
  sphFlowBase();
  sphFlowBase(const char* label);
  sphFlowBase(const char* label, int id);
  virtual ~sphFlowBase();
  virtual int initializeFlow(const sphElem* config_elem);
  virtual int initializeFlow(const SklCfg::SklSolverConfig* sklconfig);
  virtual int executeSolvers() = 0;

  // ステップ・時刻管理クラス
  sphStepTime* getStepTime() const;

};

#endif /* _SPHFLOWBASE_H_ */
