/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphFlowFactoryBase.h
 * Sphere Flow Factory super Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphFlowFactoryBase.h
 * Sphereフロー生成基底クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */

#ifndef _SPHFLOWFACTORYBASE_H_
#define _SPHFLOWFACTORYBASE_H_

#include "base/sphBase.h"
#include "solverbase/sphFlowBase.h"

/**
 * Sphereフロー生成基底クラス
 */
class sphFlowFactoryBase: public sphBase
{
public:
  sphFlowFactoryBase();
  virtual ~sphFlowFactoryBase();
  virtual sphFlowBase* factoryFlow(const char* class_name, const char* label, int id) const;
};

#endif /* _SPHFLOWFACTORYBASE_H_ */
