/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphSimpleFlow.h
 * Sphere Simple Voxel Flow super Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphSimpleFlow.h
 * Sphere構造格子フロー基底クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */

#ifndef _SPHFLOWSV_H_
#define _SPHFLOWSV_H_

#include "solverbase/sphFlowBase.h"

/**
 * Sphere構造格子フロー基底クラス
 */
class sphSimpleFlow: public sphFlowBase
{
protected:

  virtual int initializeSolvers();
  virtual int mainSolvers();
  virtual int postSolvers();

public:
  sphSimpleFlow();
  sphSimpleFlow(const char* label);
  sphSimpleFlow(const char* label, int id);
  virtual ~sphSimpleFlow();
  virtual int initializeFlow(const sphElem* config_elem);
  virtual int initializeFlow(const SklCfg::SklSolverConfig* sklconfig);
  virtual int executeSolvers();

};

#endif /* _SPHFLOWSV_H_ */
