/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphSolverFactory.h
 * Sphere Solver Factory Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphSolverFactory.h
 * Sphereソルバー生成クラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */
#ifndef _SPHSOLVERFACTORY_H_
#define _SPHSOLVERFACTORY_H_

#include "base/sphBase.h"
#include "solverbase/sphSolverBase.h"

/**
 * Sphereソルバー生成クラス
 */
class sphSolverFactory: public sphBase
{
public:
  sphSolverFactory();
  virtual ~sphSolverFactory();
  sphSolverBase* factorySolver(const char* class_name, const char* label, int id) const;
};

#endif /* _SPHSOLVERFACTORY_H_ */
