/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphSolverManager.h
 * Sphere Solver Manager Class Header File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphSolverManager.h
 * Sphereソルバーマネージャークラスヘッダーファイル
 * @author     hira
 * @date       2009/10/01
 */
#ifndef _SPHSOLVERMANAGER_H_
#define _SPHSOLVERMANAGER_H_

#include "base/sphBase.h"

// using namespace std;

class sphSolverBase;

/**
 * Sphereソルバーマネージャークラス
 */
class sphSolverManager: public sphBase
{

protected:
  std::map<int, sphSolverBase*> m_mapSolver;

  bool initialize();
  bool finalize();

public:
  sphSolverManager();
  virtual ~sphSolverManager();

  int getSolverCount() const;
  sphSolverBase* getSolver(int id = 0) const;
  sphSolverBase* getSolverById(int solverId) const;
  sphSolverBase* getSolverByLabel(const char* solverLabel) const;
  bool addSolver(sphSolverBase* solver);

};

#endif /* _SPHSOLVERMANAGER_H_ */
