/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sph_file_util.h
 * utility function for Linux File System
 * @author     hira
 * @date       2009/02/20
 *
 * \~japanese
 * @file sph_file_util.h
 * LINUX用ファイルユーティリティファイル
 * @author     hira
 * @date       2009/02/20
 */


#ifndef _SPH_FILE_UTIL_H
#define _SPH_FILE_UTIL_H

#if defined(_WIN32) || defined(WIN32)
#else     /* linux */

/**
 * 相対パスであるか絶対パスであるか判断する.
 * linuxシステム用
 * @param               path    チェックパス名
 * @return              true:相対パス/false:絶対パス
 */
static bool PathIsRelative(const char* path)
{
  if (path == NULL) return false;
  if (path[0] == '/') return false;
  return true;
}

#endif /* linux */
#endif /* _SPH_FILE_UTIL_H */
