/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file spl_errno.h
 * Declaration of Error Number for Sphere Low Level Library
 *
 * DO NOT INCLUDE THIS FILE DIRECTLY
 * @author     hira
 * @date       2009/02/20
 *
 * \~japanese
 * @file spl_errno.h
 * Sphereエラー番号定義ファイル
 *
 * このヘッダーファイルの直接インクルード禁止
 * @author     hira
 * @date       2009/02/20
 */


#ifndef _SPL_ERROR_NO_H_
#define _SPL_ERROR_NO_H_

#define SPL_SUCCESS      0
#define SPL_ERR_MPI_ERROR    1
#define SPL_ERR_INVALID_PARAMETER  2
#define SPL_ERR_MEMORY_ALLOCATE    3
#define SPL_ERR_OPEN_FILE    4
#define SPL_ERR_READ_FILE    5
#define SPL_ERR_WRITE_FILE    6
#define SPL_ERR_SEEK_FILE    7
#define SPL_ERR_DETECT_ILLEGAL_EOF  8
#define SPL_ERR_NULL_POINTER    9
#define SPL_ERR_STR_SIZE_TOO_LONG       10
#define SPL_ERR_INVALID_SPLSV_DTYPE  11
#define SPL_ERR_DATA_IS_NULL    12
#define SPL_ERR_INVALID_ARRAY_SIZE  13
#define SPL_ERR_INVALID_MAGICK_NO  14
#define SPL_ERR_INVALID_ENDIAN_TYPE  15
#define SPL_ERR_COMPRESS_DATA    16
#define SPL_ERR_UNCOMPRESS_DATA    17
#define SPL_ERR_BUFFER_OVERFLOW    18
#define SPL_ERR_CONSTRACTOR    19
#define SPL_ERR_STL    20
#define SPL_ERR_INITIALIZE    21
#define SPL_ERR_INVALID_ENVIRONMENT  22
#define SPL_ERR_CAST_NULL  23
#define SPL_ERR_NOT_SUPPORT_METHOD  24
#define SPL_ERR_NOT_FOUND_IN_LIST  25
#define SPL_ERR_ALLREDUCE_SUM  26
#define SPL_ERR_FSTAT_FILE  27
#define SPL_ERR_INTERNAL_IMPOSSIBLE  28
#define SPL_ERR_START_IDX  29
#define SPL_ERR_RECODE_SIZE  30


#define SPL_ERR_LASTCODE    50

#endif /* _SPL_ERROR_NO_H_ */

