/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file splmpi.h
 * MPI wrapper for Sphere Low Level Library
 * @author     hira
 * @date       2009/02/20
 *
 * \~japanese
 * @file splmpi.h
 * MPIラッパーヘッダーファイル
 * @author     hira
 * @date       2009/02/20
 */


#ifndef _SPL_MESSAGE_PASSING_INTERFACE_H_
#define _SPL_MESSAGE_PASSING_INTERFACE_H_

#include "spl.h"
#include "spl/splfio_sv_file.h"


#ifdef SPL_MPI_INLINE
 #undef SPL_MPI_INLINE
#endif /* SPL_MPI_INLINE */

#ifndef NO_INLINE
// #define SPL_MPI_INLINE inline
 #define SPL_MPI_INLINE static inline
#else
 #define SPL_MPI_INLINE
#endif /* NO_INLINE */

#if defined( _HAS_MPICH_ )
  #include "splmpi_mpi.h"
  #include "splmpi_mpi_errno.h"
#elif defined( _HAS_OMPI_ )
  #include "splmpi_mpi.h"
  #include "splmpi_mpi_errno.h"
#else
  #include "splmpi_dmy.h"
  #include "splmpi_dmy_errno.h"
#endif

#undef SPL_MPI_INLINE

#endif /* _SPL_MESSAGE_PASSING_INTERFACE_H_ */

