/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file splmpi_dmy_inline.h
 * Implementation Dummy MPI wrapper for Sphere Low Level Library
 *
 * DO NOT INCLUDE THIS FILE DIRECTLY
 * @author     hira
 * @date       2009/02/20
 *
 * \~japanese
 * @file splmpi_dmy_inline.h
 * ダミーMPIラッパー関数郡インラインファイル
 *
 * 逐次処理用のMPI関数、定義のダミー関数、定義<br>
 * 逐次処理にてMPI関数は何もせず、SPL_MPI_SUCCESSを返す。<br>
 * このヘッダーファイルの直接インクルード禁止
 * @author     hira
 * @date       2009/02/20
 */


#ifndef _SPL_MPI_DMY_INLINE_H_
#define _SPL_MPI_DMY_INLINE_H_

/* for gettimeofday (SPL_Wtime and SPL_Wtick) */
// 20070417 #include <stdio.h>
#include <sys/time.h>

/* int MPI_Send(void*, int, MPI_Datatype, int, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Send(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Recv(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Recv(void *buf, int count, SPL_Datatype datatype, int source, int tag, SPL_Comm comm, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Get_count(MPI_Status *, MPI_Datatype, int *) */
SPL_MPI_INLINE int
SPL_Get_count(SPL_Status *status, SPL_Datatype datatype, int *count) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Bsend(void*, int, MPI_Datatype, int, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Bsend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Ssend(void*, int, MPI_Datatype, int, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Ssend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm ) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Rsend(void*, int, MPI_Datatype, int, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Rsend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Buffer_attach( void*, int) */
SPL_MPI_INLINE int
SPL_Buffer_attach(void *buffer, int size) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Buffer_detach( void*, int*) */
SPL_MPI_INLINE int
SPL_Buffer_detach(void *bufferptr, int *size) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Isend(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Isend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Ibsend(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Ibsend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Issend(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Issend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Irsend(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Irsend(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Irecv(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Irecv(void *buf, int count, SPL_Datatype datatype, int source, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Wait(MPI_Request *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Wait(SPL_Request *request, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Test(MPI_Request *, int *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Test(SPL_Request *request, int *flag, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Request_free(MPI_Request *) */
SPL_MPI_INLINE int
SPL_Request_free(SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Waitany(int, MPI_Request *, int *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Waitany(int count, SPL_Request array_of_requests[], int *index, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Testany(int, MPI_Request *, int *, int *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Testany(int count, SPL_Request array_of_requests[], int *index, int *flag, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Waitall(int, MPI_Request *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Waitall(int count, SPL_Request array_of_requests[], SPL_Status array_of_statuses[]) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Testall(int, MPI_Request *, int *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Testall(int count, SPL_Request array_of_requests[], int *flag, SPL_Status array_of_statuses[]) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Waitsome(int, MPI_Request *, int *, int *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Waitsome(int incount, SPL_Request array_of_requests[], int *outcount, int array_of_indices[], SPL_Status array_of_statuses[]) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Testsome(int, MPI_Request *, int *, int *, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Testsome(int incount, SPL_Request array_of_requests[], int *outcount, int array_of_indices[], SPL_Status array_of_statuses[]) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Iprobe(int, int, MPI_Comm, int *flag, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Iprobe(int source, int tag, SPL_Comm comm, int *flag, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Probe(int, int, MPI_Comm, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Probe(int source, int tag, SPL_Comm comm, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cancel(MPI_Request *) */
SPL_MPI_INLINE int
SPL_Cancel(SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Test_cancelled(MPI_Status *, int *) */
SPL_MPI_INLINE int
SPL_Test_cancelled(SPL_Status *status, int *flag) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Send_init(void*, int, MPI_Datatype, int, int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Send_init(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Bsend_init(void*, int, MPI_Datatype, int,int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Bsend_init(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Ssend_init(void*, int, MPI_Datatype, int,int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Ssend_init(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Rsend_init(void*, int, MPI_Datatype, int,int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Rsend_init(void *buf, int count, SPL_Datatype datatype, int dest, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Recv_init(void*, int, MPI_Datatype, int,int, MPI_Comm, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Recv_init(void *buf, int count, SPL_Datatype datatype, int source, int tag, SPL_Comm comm, SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Start(MPI_Request *) */
SPL_MPI_INLINE int
SPL_Start(SPL_Request *request) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Startall(int, MPI_Request *) */
SPL_MPI_INLINE int
SPL_Startall(int count, SPL_Request array_of_requests[]) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Sendrecv(void *, int, MPI_Datatype,int, int, void *, int, MPI_Datatype, int, int, MPI_Comm, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Sendrecv(void *sendbuf, int sendcount, SPL_Datatype sendtype, int dest, int sendtag, void *recvbuf, int recvcount, SPL_Datatype recvtype, int source, int recvtag, SPL_Comm comm, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Sendrecv_replace(void*, int, MPI_Datatype, int, int, int, int, MPI_Comm, MPI_Status *) */
SPL_MPI_INLINE int
SPL_Sendrecv_replace(void *buf, int count, SPL_Datatype datatype, int dest, int sendtag, int source, int recvtag, SPL_Comm comm, SPL_Status *status) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_contiguous(int, MPI_Datatype, MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_contiguous(int count, SPL_Datatype old_type, SPL_Datatype *newtype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_vector(int, int, int, MPI_Datatype, MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_vector(int count, int blocklen, int stride, SPL_Datatype old_type, SPL_Datatype *newtype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_hvector(int, int, MPI_Aint, MPI_Datatype, MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_hvector(int count, int blocklen, SPL_Aint stride, SPL_Datatype old_type, SPL_Datatype *newtype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_indexed(int, int *, int *, MPI_Datatype, MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_indexed(int count, int blocklens[], int indices[], SPL_Datatype old_type, SPL_Datatype *newtype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_hindexed(int, int *, MPI_Aint *, MPI_Datatype, MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_hindexed(int count, int blocklens[], SPL_Aint indices[], SPL_Datatype old_type, SPL_Datatype *newtype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_struct(int, int *, MPI_Aint *, MPI_Datatype *, MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_struct(int count, int blocklens[], SPL_Aint indices[], SPL_Datatype old_types[], SPL_Datatype *newtype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Address(void*, MPI_Aint *) */
SPL_MPI_INLINE int
SPL_Address(void *location, SPL_Aint *address) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_extent(MPI_Datatype, MPI_Aint *) */
SPL_MPI_INLINE int
SPL_Type_extent(SPL_Datatype datatype, SPL_Aint *extent) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_size(MPI_Datatype, int *) */
SPL_MPI_INLINE int
SPL_Type_size(SPL_Datatype datatype, int *size)
{
  *size = spl_get_datasize(datatype);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Type_lb(MPI_Datatype, MPI_Aint*) */
SPL_MPI_INLINE int
SPL_Type_lb(SPL_Datatype datatype, SPL_Aint *displacement) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_ub(MPI_Datatype, MPI_Aint*) */
SPL_MPI_INLINE int
SPL_Type_ub(SPL_Datatype datatype, SPL_Aint *displacement) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_commit(MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_commit(SPL_Datatype *datatype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Type_free(MPI_Datatype *) */
SPL_MPI_INLINE int
SPL_Type_free(SPL_Datatype *datatype) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Get_elements(MPI_Status *, MPI_Datatype, int *) */
SPL_MPI_INLINE int
SPL_Get_elements(SPL_Status *status, SPL_Datatype datatype, int *elements) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Pack(void*, int, MPI_Datatype, void *, int, int *,  MPI_Comm) */
SPL_MPI_INLINE int
SPL_Pack(void *inbuf, int incount, SPL_Datatype datatype, void *outbuf, int outcount, int *position, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Unpack(void*, int, int *, void *, int, MPI_Datatype, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Unpack(void *inbuf, int insize, int *position, void *outbuf, int outcount, SPL_Datatype datatype, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Pack_size(int, MPI_Datatype, MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Pack_size(int incount, SPL_Datatype datatype, SPL_Comm comm, int *size) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Barrier(MPI_Comm ) */
SPL_MPI_INLINE int
SPL_Barrier(SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Bcast(void*, int, MPI_Datatype, int, MPI_Comm ) */
SPL_MPI_INLINE int
SPL_Bcast(void *buffer, int count, SPL_Datatype datatype, int root, SPL_Comm comm)
{
  return SPL_MPI_SUCCESS;
}

/* int MPI_Gather(void* , int, MPI_Datatype, void*, int, MPI_Datatype, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Gather(void *sendbuf, int sendcnt, SPL_Datatype sendtype, void *recvbuf, int recvcount, SPL_Datatype recvtype, int root, SPL_Comm comm)
{
  int size = 0;
  SPL_Type_size(sendtype, &size);
  memcpy(recvbuf, sendbuf, size*sendcnt);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Gatherv(void* , int, MPI_Datatype, void*, int *, int *, MPI_Datatype, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Gatherv(void *sendbuf, int sendcnt, SPL_Datatype sendtype, void *recvbuf, int *recvcnts, int *displs, SPL_Datatype recvtype, int root, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Scatter(void* , int, MPI_Datatype, void*, int, MPI_Datatype, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Scatter(void *sendbuf, int sendcnt, SPL_Datatype sendtype, void *recvbuf, int recvcnt, SPL_Datatype recvtype, int root, SPL_Comm comm)
{
  int size = 0;
  SPL_Type_size(sendtype, &size);
  memcpy(recvbuf, sendbuf, size*sendcnt);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Scatterv(void* , int *, int *,  MPI_Datatype, void*, int, MPI_Datatype, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Scatterv(void *sendbuf, int *sendcnts, int *displs, SPL_Datatype sendtype, void *recvbuf, int recvcnt, SPL_Datatype recvtype, int root, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Allgather(void* , int, MPI_Datatype, void*, int, MPI_Datatype, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Allgather(void *sendbuf, int sendcount, SPL_Datatype sendtype, void *recvbuf, int recvcount, SPL_Datatype recvtype, SPL_Comm comm)
{
  int size = 0;
  SPL_Type_size(sendtype, &size);
  memcpy(recvbuf, sendbuf, size*sendcount);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Allgatherv(void* , int, MPI_Datatype, void*, int *, int *, MPI_Datatype, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Allgatherv(void *sendbuf, int sendcount, SPL_Datatype sendtype, void *recvbuf, int *recvcounts, int *displs, SPL_Datatype recvtype, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Alltoall(void* , int, MPI_Datatype, void*, int, MPI_Datatype, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Alltoall(void *sendbuf, int sendcount, SPL_Datatype sendtype, void *recvbuf, int recvcnt, SPL_Datatype recvtype, SPL_Comm comm)
{
  int size = 0;
  SPL_Type_size(sendtype, &size);
  memcpy(recvbuf, sendbuf, size*sendcount);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Alltoallv(void* , int *, int *, MPI_Datatype, void*, int *, int *, MPI_Datatype, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Alltoallv(void *sendbuf, int *sendcnts, int *sdispls, SPL_Datatype sendtype, void *recvbuf, int *recvcnts, int *rdispls, SPL_Datatype recvtype, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Reduce(void* , void*, int, MPI_Datatype, MPI_Op, int, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Reduce(void *sendbuf, void *recvbuf, int count, SPL_Datatype datatype, SPL_Op op, int root, SPL_Comm comm)
{
  int size = 0;
  SPL_Type_size(datatype, &size);
  memcpy(recvbuf, sendbuf, size*count);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Op_create(MPI_User_function *, int, MPI_Op *) */
SPL_MPI_INLINE int
SPL_Op_create(SPL_User_function *function, int commute, SPL_Op *op) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Op_free( MPI_Op *) */
SPL_MPI_INLINE int
SPL_Op_free(SPL_Op *op) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Allreduce(void* , void*, int, MPI_Datatype, MPI_Op, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Allreduce(void *sendbuf, void *recvbuf, int count, SPL_Datatype datatype, SPL_Op op, SPL_Comm comm)
{
  int size = 0;
  SPL_Type_size(datatype, &size);
  memcpy(recvbuf, sendbuf, size*count);
  return SPL_MPI_SUCCESS;
}

/* int MPI_Reduce_scatter(void* , void*, int *, MPI_Datatype, MPI_Op, MPI_Comm) */
SPL_MPI_INLINE int
SPL_Reduce_scatter(void *sendbuf, void *recvbuf, int *recvcnts, SPL_Datatype datatype, SPL_Op op, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Scan(void* , void*, int, MPI_Datatype, MPI_Op, MPI_Comm ) */
SPL_MPI_INLINE int
SPL_Scan(void *sendbuf, void *recvbuf, int count, SPL_Datatype datatype, SPL_Op op, SPL_Comm comm) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_size(MPI_Group group, int *) */
SPL_MPI_INLINE int
SPL_Group_size(SPL_Group group, int *size)
{
  if( !size ) return SPL_MPI_ERR_ARG;
  *size = 1;
  return SPL_MPI_SUCCESS;
}

/* int MPI_Group_rank(MPI_Group group, int *) */
SPL_MPI_INLINE int
SPL_Group_rank(SPL_Group group, int *rank)
{
  if( !rank ) return SPL_MPI_ERR_ARG;
  *rank = 0;
  return SPL_MPI_SUCCESS;
}

/* int MPI_Group_translate_ranks (MPI_Group, int, int *, MPI_Group, int *) */
SPL_MPI_INLINE int
SPL_Group_translate_ranks(SPL_Group group_a, int n, int *ranks_a, SPL_Group group_b, int *ranks_b) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_compare(MPI_Group, MPI_Group, int *) */
SPL_MPI_INLINE int
SPL_Group_compare(SPL_Group group1, SPL_Group group2, int *result) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_group(MPI_Comm, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Comm_group(SPL_Comm comm, SPL_Group *group) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_union(MPI_Group, MPI_Group, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_union(SPL_Group group1, SPL_Group group2, SPL_Group *group_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_intersection(MPI_Group, MPI_Group, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_intersection(SPL_Group group1, SPL_Group group2, SPL_Group *group_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_difference(MPI_Group, MPI_Group, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_difference(SPL_Group group1, SPL_Group group2, SPL_Group *group_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_incl(MPI_Group group, int, int *, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_incl(SPL_Group group, int n, int *ranks, SPL_Group *group_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_excl(MPI_Group group, int, int *, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_excl(SPL_Group group, int n, int *ranks, SPL_Group *newgroup) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_range_incl(MPI_Group group, int, int [][3], MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_range_incl(SPL_Group group, int n, int ranges[][3], SPL_Group *newgroup) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_range_excl(MPI_Group group, int, int [][3], MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_range_excl(SPL_Group group, int n, int ranges[][3], SPL_Group *newgroup) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Group_free(MPI_Group *) */
SPL_MPI_INLINE int
SPL_Group_free(SPL_Group *group) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_size(MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Comm_size(SPL_Comm comm, int *size)
{
  if( !size ) return SPL_MPI_ERR_ARG;
  *size = 1;
  return SPL_MPI_SUCCESS;
}

/* int MPI_Comm_rank(MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Comm_rank(SPL_Comm comm, int *rank) {
  if( !rank ) return SPL_MPI_ERR_ARG;
  *rank = 0;
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_compare(MPI_Comm, MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Comm_compare(SPL_Comm comm1, SPL_Comm comm2, int *result) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_dup(MPI_Comm, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Comm_dup(SPL_Comm comm, SPL_Comm *comm_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_create(MPI_Comm, MPI_Group, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Comm_create(SPL_Comm comm, SPL_Group group, SPL_Comm *comm_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_split(MPI_Comm, int, int, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Comm_split(SPL_Comm comm, int color, int key, SPL_Comm *comm_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_free(MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Comm_free(SPL_Comm *commp) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_test_inter(MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Comm_test_inter(SPL_Comm comm, int *flag) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_remote_size(MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Comm_remote_size(SPL_Comm comm, int *size) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_remote_group(MPI_Comm, MPI_Group *) */
SPL_MPI_INLINE int
SPL_Comm_remote_group(SPL_Comm comm, SPL_Group *group) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Intercomm_create(MPI_Comm, int, MPI_Comm, int, int, MPI_Comm * ) */
SPL_MPI_INLINE int
SPL_Intercomm_create (SPL_Comm local_comm, int local_leader, SPL_Comm peer_comm, int remote_leader, int tag, SPL_Comm *comm_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Intercomm_merge(MPI_Comm, int, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Intercomm_merge(SPL_Comm comm, int high, SPL_Comm *comm_out) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Keyval_create(MPI_Copy_function *, MPI_Delete_function *, int *, void*) */
SPL_MPI_INLINE int
SPL_Keyval_create(SPL_Copy_function *copy_fn, SPL_Delete_function *delete_fn, int *keyval, void *extra_state) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Keyval_free(int *) */
SPL_MPI_INLINE int
SPL_Keyval_free(int *keyval) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Attr_put(MPI_Comm, int, void*) */
SPL_MPI_INLINE int
SPL_Attr_put(SPL_Comm comm, int keyval, void *attr_value) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Attr_get(MPI_Comm, int, void *, int *) */
SPL_MPI_INLINE int
SPL_Attr_get(SPL_Comm comm, int keyval, void *attr_value, int *flag) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Attr_delete(MPI_Comm, int) */
SPL_MPI_INLINE int
SPL_Attr_delete(SPL_Comm comm, int keyval) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Topo_test(MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Topo_test(SPL_Comm comm, int *top_type) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_create(MPI_Comm, int, int *, int *, int, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Cart_create(SPL_Comm comm_old, int ndims, int *dims, int *periods, int reorder, SPL_Comm *comm_cart) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Dims_create(int, int, int *) */
SPL_MPI_INLINE int
SPL_Dims_create(int nnodes, int ndims, int *dims) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Graph_create(MPI_Comm, int, int *, int *, int, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Graph_create(SPL_Comm comm_old, int nnodes, int *index, int *edges, int reorder, SPL_Comm *comm_graph) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Graphdims_get(MPI_Comm, int *, int *) */
SPL_MPI_INLINE int
SPL_Graphdims_get(SPL_Comm comm, int *nnodes, int *nedges) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Graph_get(MPI_Comm, int, int, int *, int *) */
SPL_MPI_INLINE int
SPL_Graph_get(SPL_Comm comm, int maxindex, int maxedges, int *index, int *edges) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cartdim_get(MPI_Comm, int *) */
SPL_MPI_INLINE int
SPL_Cartdim_get(SPL_Comm comm, int *ndims) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_get(MPI_Comm, int, int *, int *, int *) */
SPL_MPI_INLINE int
SPL_Cart_get(SPL_Comm comm, int maxdims, int *dims, int *periods, int *coords) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_rank(MPI_Comm, int *, int *) */
SPL_MPI_INLINE int
SPL_Cart_rank(SPL_Comm comm, int *coords, int *rank) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_coords(MPI_Comm, int, int, int *) */
SPL_MPI_INLINE int
SPL_Cart_coords(SPL_Comm comm, int rank, int maxdims, int *coords) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Graph_neighbors_count(MPI_Comm, int, int *) */
SPL_MPI_INLINE int
SPL_Graph_neighbors_count(SPL_Comm comm, int rank, int *nneighbors) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Graph_neighbors(MPI_Comm, int, int, int *) */
SPL_MPI_INLINE int
SPL_Graph_neighbors(SPL_Comm comm, int rank, int maxneighbors, int *neighbors) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_shift(MPI_Comm, int, int, int *, int *) */
SPL_MPI_INLINE int
SPL_Cart_shift(SPL_Comm comm, int direction, int displ, int *source, int *dest) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_sub(MPI_Comm, int *, MPI_Comm *) */
SPL_MPI_INLINE int
SPL_Cart_sub(SPL_Comm comm, int *remain_dims, SPL_Comm *comm_new) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Cart_map(MPI_Comm, int, int *, int *, int *) */
SPL_MPI_INLINE int
SPL_Cart_map(SPL_Comm comm_old, int ndims, int *dims, int *periods, int *newrank) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Graph_map(MPI_Comm, int, int *, int *, int *) */
SPL_MPI_INLINE int
SPL_Graph_map(SPL_Comm comm_old, int nnodes, int *index, int *edges, int *newrank) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Get_processor_name(char *, int *) */
SPL_MPI_INLINE int
SPL_Get_processor_name(char *name, int *resultlen) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Get_version(int *, int *) */
SPL_MPI_INLINE int
SPL_Get_version(int *version, int *subversion) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Errhandler_create(MPI_Handler_function *, MPI_Errhandler *) */
SPL_MPI_INLINE int
SPL_Errhandler_create(SPL_Handler_function *function, SPL_Errhandler *errhandler) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Errhandler_set(MPI_Comm, MPI_Errhandler) */
SPL_MPI_INLINE int
SPL_Errhandler_set(SPL_Comm comm, SPL_Errhandler errhandler) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Errhandler_get(MPI_Comm, MPI_Errhandler *) */
SPL_MPI_INLINE int
SPL_Errhandler_get(SPL_Comm comm, SPL_Errhandler *errhandler) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Errhandler_free(MPI_Errhandler *) */
SPL_MPI_INLINE int
SPL_Errhandler_free(SPL_Errhandler *errhandler) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Error_string(int, char *, int *) */
SPL_MPI_INLINE int
SPL_Error_string(int errorcode, char *string, int *resultlen) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Error_class(int, int *) */
SPL_MPI_INLINE int
SPL_Error_class(int errorcode, int *errorclass) {
  return SPL_MPI_SUCCESS; }

/* double MPI_Wtime(void) */
SPL_MPI_INLINE double
SPL_Wtime() {
  struct timeval tv;
  gettimeofday(&tv, NULL);
  double t = 0.0;
  t += (double)tv.tv_sec;
  t += (double)tv.tv_usec * 1.0e-6;
  return t;
}

/* double MPI_Wtick(void) */
SPL_MPI_INLINE double
SPL_Wtick() {
  return 1.0e-6;
}

/* int MPI_Init(int *, char ***) */
SPL_MPI_INLINE int
SPL_Init(int *argc, char ***argv) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Init_thread( int *, char ***, int, int * ) */
SPL_MPI_INLINE int
SPL_Init_thread(int *argc, char ***argv, int required, int *provided) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Finalize(void) */
SPL_MPI_INLINE int
SPL_Finalize() {
  return SPL_MPI_SUCCESS; }

/* int MPI_Initialized(int *) */
SPL_MPI_INLINE int
SPL_Initialized(int *flag) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Abort(MPI_Comm, int) */
SPL_MPI_INLINE int
SPL_Abort(SPL_Comm comm, int errorcode) {
  return SPL_MPI_SUCCESS; }

/* MPI-2 communicator naming functions */
/* int MPI_Comm_set_name(MPI_Comm, char *) */
SPL_MPI_INLINE int
SPL_Comm_set_name(SPL_Comm comm, char *name) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Comm_get_name(MPI_Comm, char *, int *) */
SPL_MPI_INLINE int
SPL_Comm_get_name(SPL_Comm comm, char *namep, int *reslen) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Pcontrol(int) */
SPL_MPI_INLINE int
SPL_Pcontrol(int level) {
  return SPL_MPI_SUCCESS; }


/* int MPI_NULL_COPY_FN ( MPI_Comm, int, void *, void *, void *, int * ) */
/* int MPI_NULL_DELETE_FN ( MPI_Comm, int, void *, void * ) */
/* int MPI_DUP_FN ( MPI_Comm, int, void *, void *, void *, int * ) */

/* misc2 (MPI2) */
/* int MPI_Status_f2c( MPI_Fint *, MPI_Status * ) */
/* int MPI_Status_c2f( MPI_Status *, MPI_Fint * ) */
/* int MPI_Finalized( int * ) */
/* int MPI_Type_create_indexed_block(int, int, int *, MPI_Datatype, MPI_Datatype *) */
/* int MPI_Type_get_envelope(MPI_Datatype, int *, int *, int *, int *) */
/* int MPI_Type_get_contents(MPI_Datatype, int, int, int, int *, MPI_Aint *, MPI_Datatype *) */
/* int MPI_Type_create_subarray(int, int *, int *, int *, int, MPI_Datatype, MPI_Datatype *) */
/* int MPI_Type_create_darray(int, int, int, int *, int *, int *, int *, int, MPI_Datatype, MPI_Datatype *) */
/* int MPI_Info_create(MPI_Info *) */
/* int MPI_Info_set(MPI_Info, char *, char *) */
/* int MPI_Info_delete(MPI_Info, char *) */
/* int MPI_Info_get(MPI_Info, char *, int, char *, int *) */
/* int MPI_Info_get_valuelen(MPI_Info, char *, int *, int *) */
/* int MPI_Info_get_nkeys(MPI_Info, int *) */
/* int MPI_Info_get_nthkey(MPI_Info, int, char *) */
/* int MPI_Info_dup(MPI_Info, MPI_Info *) */
/* int MPI_Info_free(MPI_Info *info) */

/* MPI_Fint MPI_Info_c2f(MPI_Info) */
/* MPI_Info MPI_Info_f2c(MPI_Fint) */
/* MPI_Fint MPI_Request_c2f( MPI_Request ) */

/* external */
/* int MPI_Status_set_cancelled( MPI_Status *, int ) */
SPL_MPI_INLINE int
SPL_Status_set_cancelled(SPL_Status *status, int flag) {
  return SPL_MPI_SUCCESS; }

/* int MPI_Status_set_elements( MPI_Status *, MPI_Datatype, int ) */
SPL_MPI_INLINE int
SPL_Status_set_elements(SPL_Status *status, SPL_Datatype datatype, int count) {
  return SPL_MPI_SUCCESS; }

#endif /* _SPL_MPI_DMY_INLINE_H_ */

