###
#############################################################
# SPHERE - Skeleton for PHysical and Engineering REsearch   #
#                                                           #
# Copyright (c) RIKEN, Japan. All right reserved. 2004-2009 #
#############################################################
###

SRCS = \
	SklCfgBase.C \
	SklCfgDomainInfo.C \
	SklCfgHistory.C \
	SklCfgInFile.C \
	SklCfgInnerBnd.C \
	SklCfgMBoxTable.C \
	SklCfgMdmTable.C \
	SklCfgNodeBase.C \
	SklCfgOutFile.C \
	SklCfgOuterBnd.C \
	SklCfgParameter.C \
	SklCfgSteer.C \
	SklCfgSteerInputData.C \
	SklCfgSteerOutputData.C \
	SklCfgUsrDefNode.C \
	SklCfgUsrDefTopNode.C \
	SklIBCConfig.C \
	SklOBCConfig.C \
	SklMBoxConfig.C \
	SklMDMConfig.C \
	SklSolverConfig.C

HEADER_INST_DIR = $(INSTALLDIR)/include
CONFIG_SUB_DIR = config
HEADERS = \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgBase.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgDatas.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgDefName.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgDomainInfo.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgErrMsg.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgHistory.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgInFile.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgInnerBnd.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgMBoxTable.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgMdmTable.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgNodeBase.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgOutFile.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgOuterBnd.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgParameter.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgSteer.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgSteerInputData.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgSteerOutputData.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgUsrDefNode.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklCfgUsrDefTopNode.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklIBCConfig.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklOBCConfig.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklMBoxConfig.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklMDMConfig.h \
	$(SPH_INC_DIR)/$(CONFIG_SUB_DIR)/SklSolverConfig.h


.SUFFIXES: .o .C .c
OBJS = $(SRCS:.C=.o)
all : $(TARGET)

$(TARGET): $(OBJS)
	$(AR) $(TARGET) $(OBJS)

install:
	$(INSTALL_LIB) $(TARGET) $(INSTALLDIR)/lib/$(TARGET)
	$(RANLIB) $(INSTALLDIR)/lib/$(TARGET)
	$(MKDIR) $(HEADER_INST_DIR)/$(CONFIG_SUB_DIR)
	$(INSTALL_HEADER) $(HEADERS) $(HEADER_INST_DIR)/$(CONFIG_SUB_DIR)/.

.C.o:
	$(CXX) $(CXXFLAGS) -c $<

clean:
	$(RM) $(TARGET) $(OBJS)

depend:
	$(MAKEDEPEND) -I. -I$(SPH_INC_DIR) $<

