/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgInnerBnd.C
 * コンフィグレーションInnerBoundary要素クラスソースファイル
 * @author     riken
 * @date       2010/10/01
 */

#include <string.h> // add 20090629
#include "skl_config/SklCfgDefName.h"
#include "skl_config/SklCfgInnerBnd.h"

namespace SklCfg {
/**
 * コンストラクタ
 */
SklCfgInnerBnd::SklCfgInnerBnd()
{
}

/**
 * デストラクタ
 */
SklCfgInnerBnd::~SklCfgInnerBnd()
{
}

bool SklCfgInnerBnd::CheckNodeName(const char* nname)
{
  if( !nname ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0001_);
    return false;
  }

  if( StrCaseCompare(nname,
                     _SKL_CFG_NNAME_INNER_BND_,
                     strlen(_SKL_CFG_NNAME_INNER_BND_)) ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0002_, nname);
    return false;
  }

  return true;
}

bool SklCfgInnerBnd::ParseSklDefNode(xmlNodePtr node)
{
  if( !node ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0003_);
    return false;
  }

  return true;
}

bool SklCfgInnerBnd::Verification()
{
  return true;
}

#ifdef DEBUG
void SklCfgInnerBnd::Print()
{
  cout << " <-- InnerBoundary --" << endl << flush;
  cout << "  -- InnerBoundary -->" << endl << flush;
}
#endif //DEBUG

} // end of namespace SklCfg

