/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgMBoxTable.C
 * コンフィグレーションMultiBoxDivTable要素クラスソースファイル
 * @author     riken
 * @date       2010/10/01
 */

#include <string.h> // add 20090629
#include "skl_config/SklCfgDefName.h"
#include "skl_config/SklCfgMBoxTable.h"

namespace SklCfg {
/**
 * コンストラクタ
 */
SklCfgMBoxTable::SklCfgMBoxTable()
{
}

/**
 * デストラクタ
 */
SklCfgMBoxTable::~SklCfgMBoxTable()
{
}

bool SklCfgMBoxTable::CheckNodeName(const char* nname)
{
  if( !nname ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0001_);
    return false;
  }

  if( StrCaseCompare(nname,
                     _SKL_CFG_NNAME_MBX_TABLE_,
                     strlen(_SKL_CFG_NNAME_MBX_TABLE_)) ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0002_, nname);
    return false;
  }

  return true;
}

bool SklCfgMBoxTable::ParseSklDefNode(xmlNodePtr node)
{
  if( !node ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0003_);
    return false;
  }

  return true;
}

bool SklCfgMBoxTable::Verification()
{
  return true;
}

#ifdef DEBUG
void SklCfgMBoxTable::Print()
{
  cout << " <-- Medium_Table --" << endl << flush;
  cout << "  -- Medium_Table -->" << endl << flush;
}
#endif //DEBUG

} // end of namespace SklCfg

