/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */
/**
 * @file SklCfgParameter.C
 * コンフィグレーションParameter要素クラスソースファイル
 * @author     riken
 * @date       2010/10/01
 */

#include <string.h> // add 20090629
#include "skl_config/SklCfgDefName.h"
#include "skl_config/SklCfgParameter.h"

namespace SklCfg {
/**
 * コンストラクタ
 */
SklCfgParameter::SklCfgParameter()
{
}

/**
 * デストラクタ
 */
SklCfgParameter::~SklCfgParameter()
{
}

bool SklCfgParameter::CheckNodeName(const char* nname)
{
  if( !nname ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0001_);
    return false;
  }

  if( StrCaseCompare(nname,
                     _SKL_CFG_NNAME_PARAMETER_,
                     strlen(_SKL_CFG_NNAME_PARAMETER_)) ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0002_, nname);
    return false;
  }

  return true;
}

bool SklCfgParameter::ParseSklDefNode(xmlNodePtr node)
{
  if( !node ){
    CfgDbgMsg("%s (%d): ",__FILE__, __LINE__);
    CfgErrMsg(_SKL_CFG_ERR_0003_);
    return false;
  }

  return true;
}

bool SklCfgParameter::Verification()
{
  return true;
}

#ifdef DEBUG
void SklCfgParameter::Print()
{
  cout << " <-- Parameter --" << endl << flush;
  cout << "  -- Parameter -->" << endl << flush;
}
#endif //DEBUG

} // end of namespace SklCfg

