/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file sphCouplerUns2Sv.C
 * Sphere Unsteady to Simple Voxel Coupler super Class Source File
 * @author     hira
 * @date       2009/10/01
 *
 * \~japanese
 * @file sphCouplerUns2Sv.C
 * Sphere非構造格子To構造格子カプラー基底クラスソースファイル
 * @author     hira
 * @date       2009/10/01
 */

#include "solverbase/sphCouplerUns2Sv.h"


/**
 * \~english
 * Constructor
 *
 * \~japanese
 * コンストラクタ
 */
sphCouplerUns2Sv::sphCouplerUns2Sv()
{


}

/**
 * \~english
 * Constructor
 * @param     label     coupler label
 *
 * \~japanese
 * コンストラクタ
 * @param     label     カプラーラベル
 */
sphCouplerUns2Sv::sphCouplerUns2Sv(const char* label) : sphCouplerBase(label, 0)
{

}


/**
 * \~english
 * Constructor
 * @param     label     coupler label
 * @param     id     coupler id
 *
 * \~japanese
 * コンストラクタ
 * @param     label     カプラーラベル
 * @param     id     カプラーID
 */
sphCouplerUns2Sv::sphCouplerUns2Sv(const char* label, int id) : sphCouplerBase(label, id)
{

}


/**
 * \~english
 * Destructor
 *
 * \~japanese
 * デストラクタ.
 */
sphCouplerUns2Sv::~sphCouplerUns2Sv()
{

}


/**
 * カプラの初期化を行う（データラベル指定）.
 * 通信ノード、ボクセル情報のテーブルを作成する。
 * @param               ref_reg_label         参照データ登録ラベル
 * @param               upd_reg_label         更新データ登録ラベル
 * @return              -1:error, 0:forced terminated, 1:normality
 */
int
sphCouplerUns2Sv::initializeCoupler(const char* ref_reg_label, const char* upd_reg_label)
{
  return SPHERE_SUCCESS;
}

/**
 * カプラーの実行を行う.
 * @param               void
 * @return              -1:error, 0:forced terminated, 1:normality
 */
int
sphCouplerUns2Sv::executeCoupler()
{
  return SPHERE_SUCCESS;
}


/**
 * \~english
 * post Coupler.
 * @param               void
 * @return              -1:error, 0:forced terminated, 1:normality
 *
 * \~japanese
 * カプラーの破棄処理を行う.
 * @param               void
 * @return              -1:error, 0:forced terminated, 1:normality
 */
int
sphCouplerUns2Sv::postCoupler()
{
  return SPHERE_SUCCESS;
}



/**
 * 参照データオブジェクトの取得を行う.
 * 参照データのノードからデータを受信する。
 * @param               void
 * @return    success(=true)/fault(=false)
 */
bool sphCouplerUns2Sv::communicateData()
{

  return true;
}


/**
 * 参照データから更新データに補間を行い、データをセットする
 * @return    success(=true)/fault(=false)
 */
bool sphCouplerUns2Sv::interpolate()
{
  return true;
}




