/*************************************************************
   SPHERE - Skeleton for PHysical and Engineering REsearch
   Copyright (c) RIKEN, Japan. All right reserved. 2004-2010
 *************************************************************/
/**
 * \~english
 * @file splfio_sph_io.h
 * Implementation of SPH utility subroutine.
 *
 * DO NOT INCLUDE THIS FILE DIRECTLY
 * @author     yoh
 * @date       2009/11/27
 *
 * \~japanese
 * @file splfio_sph_io.h
 * SPHファイルの低レベル入出力関数ヘッダーファイル
 *
 * このヘッダーファイルの直接インクルード禁止
 * @author     yoh
 * @date       2009/11/27
 */

#ifndef _SPL_FIO_SPH_IO_H_
#define _SPL_FIO_SPH_IO_H_

#include <stdio.h>

#if defined(__cplusplus)
extern "C" {
#endif

SplBool
getSphInfo(int mode, int readRank, SPL_Comm grp, const char* fname,
           splSpx* obj, EMatchType* etype);

SplBool
writeSphHeaderRecord(FILE* fp,
                     int mode,
                     int writeRank,
                     SPL_Comm grp,
                     unsigned int vlen,
                     unsigned int rlen,
                     const size_t* size,
                     const double* org,
                     const double* pit,
                     size_t step,
                     double time);

SplBool
writeSphDataRecord( int mode,
                    int writeRank,
                    SPL_Comm grp,
                    FILE* fp,
                    size_t vox_num_per_blk,
                    unsigned int vlen,
                    unsigned int rlen,
                    const size_t* vsz,
                    const unsigned char* data,
                    const size_t* wsize,
                    const size_t* sta_idx);

#if defined(__cplusplus)
}
#endif /* extern "C" */

#endif /* _SPL_FIO_SPH_IO_H_ */
