/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2008
 *
 */

#ifndef _SKL_SPH_DATA_SET_H_
#define _SKL_SPH_DATA_SET_H_

#include <string.h>
#include <stdlib.h>
#include <iostream>

#include "SklVoxDataSet.h"
#include "endianUtil.h"

using namespace std;

class SklSphDataSet : public SklVoxDataSet {
protected:
  bool ReadAttrRecord(FILE* fp, EMatchType eType);
  bool ReadVoxSizeRecord(FILE* fp, EMatchType eType);
  bool ReadVoxOriginRecord(FILE* fp, EMatchType eType);
  bool ReadVoxPitchRecord(FILE* fp, EMatchType eType);
  bool ReadTimeRecord(FILE* fp, EMatchType eType);

// modify start for vsphere_cmp at 2008/08/15 by @hira
//  bool ReadDataRecord(FILE* fp,
//                      const unsigned* size,
//                      unsigned vc,
//                      EMatchType eType);
  bool ReadDataRecord(FILE* fp,
                      const unsigned int* size,
                      unsigned int vc,
                      EMatchType eType,
                      int procGrp);
// modify end for vsphere_cmp at 2008/08/15 by @hira

  bool WriteAttrRecord(FILE* fp);
  bool WriteVoxSizeRecord(FILE* fp, unsigned gc = 0);
  bool WriteVoxOriginRecord(FILE* fp, unsigned gc = 0);
  bool WriteVoxPitchRecord(FILE* fp);
  bool WriteTimeRecord(FILE* fp);
  bool WriteDataRecord(FILE* fp, unsigned gc = 0);

public:
  SklSphDataSet(){
    m_fmt = SPH_FMT;

    m_DATANUM = 1;
  };
  virtual ~SklSphDataSet() {};

  bool Read(const char* fname);

  virtual bool Read(const char* fname,
                    const unsigned* size,
                    unsigned vc,
                    bool multi_io_flag = false,
                    int procGrp = 0);

  virtual bool Write(const char* fname,
                     unsigned gc = 0,
                     bool multi_io_flag = false,
                     int procGrp = 0);

  std::string printInformation();

};

#endif // _SKL_SPH_DATA_SET_H_

